///////////////////////////////////////////////////////////////////////////////
/*
                            geolocate_ipstack.js

https://ipstack.com/
https://ipstack.com/documentation

This service requires registration and has free and paid accounts.

This module caches geo data and so only accesses the service once for each
unique host begin resolved.  The module must be edited to set the access code.


COPYRIGHT
---------
Copyright (C) 2018 Mark G.Daniel
This program, comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it under the
conditions of the GNU GENERAL PUBLIC LICENSE, version 3, or any later version.
http://www.gnu.org/licenses/gpl.txt


VERSION
-------
06-NOV-2018  MGD  initial
*/
///////////////////////////////////////////////////////////////////////////////

// you will need to edit this string inserting your authorisation access key
var geoLocateIpStackAccessKey = '';

var geoLocateHost = [];
var geoLocateData = [];

///////////////////////////////////////////////////////////////////////////////

function geoLocate (id, host)
{
   var gld, idx, jsn, url, xhr;

   if (!host)
   {
      document.getElementById(id).innerHTML = '';
      return;
   }

   for (idx = 0; idx < geoLocateHost.length; idx++)
      if (geoLocateHost[idx] == host) break;

   if (!geoLocateData[idx])
   {
      geoLocateHost[idx] = host;
      geoLocateData[idx] = '';
      geoLocateIpStack(id,idx,host);
   }

   document.getElementById(id).innerHTML = geoLocateData[idx];
}

///////////////////////////////////////////////////////////////////////////////

function geoLocateIpStack(id,idx,host)
{
   var url = location.protocol + '//api.ipstack.com/' +
             host + '?access_key=' + geoLocateIpStackAccessKey +
             '&output=json';

   var xhr = new XMLHttpRequest();

   xhr.open('GET', url, true);

   xhr.onreadystatechange = function()
   {
      if (this.readyState == 4)
      {
         var gld;
         if (this.status == 200)
         {
            jsn = JSON.parse(this.responseText);

            gld = ' {';

            if (jsn['type'])
            {
               if (jsn['country_name'] == null)
                  gld += '?';
               else
                  gld += jsn['country_name'];

               if (jsn['region_name'] != null &&
                   jsn['region_name'] != jsn['country_name'])
                  gld += ', ' + jsn['region_name'];

               if (jsn['city'] != null && jsn['city'] != jsn['region_name'])
                  gld += ', ' + jsn['city'];

//               if (jsn['region_name'] == null && jsn['city'] == null &&
//                   jsn['latitude'] != null && jsn['longitude'] != null)
//                  gld += ' ' + jsn['latitude'] + ',' + jsn['longitude'];
            }
            else
            if (jsn['error'])
               gld += jsn['error']['type'];
            else
               gld += 'bugcheck';

            gld += '}';
         }
         else
         if (this.status)
         {
            gld = ' {HTTP ' + this.status + ' error}';
         }
         else
            gld = '';

         geoLocateData[idx] = gld;
         document.getElementById(id).innerHTML = gld;
      }
   };

   xhr.send(); 
}

///////////////////////////////////////////////////////////////////////////////

